/**
 * materialize-tags - A jQuery tags input plugin based on Materialize
 * @version v1.2.0
 * @link https://github.com/henrychavez/materialize-tags
 * @license MIT
 * @author Henry Chávez <henry19.chavez@gmail.com>
 * @maintainer Jonathan Dekhtiar <contact@jonathandekhtiar.eu>
 */
!function(t){"use strict";function e(e,i){this.itemsArray=[],this.$element=t(e),this.$element.hide(),this.objectItems=i&&i.itemValue,this.placeholderText=e.hasAttribute("placeholder")?this.$element.attr("placeholder"):"",this.inputSize=Math.max(1,this.placeholderText.length),this.$container=t('<div class="materialize-tags"></div>'),this.$input=t('<input type="text" class="n-tag"  placeholder="'+this.placeholderText+'"/>').appendTo(this.$container),this.$label=this.$element.parent().find("label"),this.$element.before(this.$container),this.build(i),this.$label.on("click",function(){t(this).addClass("active"),t(this).addClass("infocus"),t(this).next(".materialize-tags").find("input.n-tag").focus()}),this.$input.on("focus",function(){var e=t(this).parents(".materialize-tags").parent().find("label");t(this).parents(".materialize-tags").addClass("active"),+!e.hasClass("infocus")&&e.addClass("infocus"),e.hasClass("active")||e.addClass("active")}).on("focusout",function(){var e=t(this).parents(".materialize-tags"),i=e.find("span.chip");e.removeClass("active"),e.parent().find("label").removeClass("infocus"),0==i.length&&0==t(this).val().length&&e.parent().find("label").removeClass("active")})}function i(t,e){if("function"!=typeof t[e]){var i=t[e];t[e]=function(t){return t[i]}}}function a(t,e){if("function"!=typeof t[e]){var i=t[e];t[e]=function(){return i}}}function n(t){return t?l.text(t).html():""}function r(t){var e=0;if(document.selection){t.focus();var i=document.selection.createRange();i.moveStart("character",-t.value.length),e=i.text.length}else(t.selectionStart||"0"==t.selectionStart)&&(e=t.selectionStart);return e}function s(e,i){var a=!1;return t.each(i,function(t,i){if("number"==typeof i&&e.which===i)return a=!0,!1;if(e.which===i.which){var n=!i.hasOwnProperty("altKey")||e.altKey===i.altKey,r=!i.hasOwnProperty("shiftKey")||e.shiftKey===i.shiftKey,s=!i.hasOwnProperty("ctrlKey")||e.ctrlKey===i.ctrlKey;if(n&&r&&s)return a=!0,!1}}),a}var o={tagClass:function(t){return"chip"},itemValue:function(t){return t?t.toString():t},itemText:function(t){return this.itemValue(t)},itemTitle:function(t){return null},freeInput:!0,addOnBlur:!0,maxTags:void 0,maxChars:void 0,confirmKeys:[9,13,44,188],onTagExists:function(t,e){e.hide().fadeIn()},trimValue:!0,allowDuplicates:!1,deleteTagsOnBackspace:!0,deleteTagsOnDeleteKey:!0,MoveTagOnLeftArrow:!0,MoveTagOnRightArrow:!0,autoselect:!1,CapitalizeFirstLetterOnly:!1};e.prototype={constructor:e,add:function(e,i,a){var r=this;if(!(r.options.maxTags&&r.itemsArray.length>=r.options.maxTags)&&(!1===e||e)){if("string"==typeof e&&r.options.trimValue&&(e=t.trim(e)),"string"==typeof e&&r.options.CapitalizeFirstLetterOnly&&(e=e.charAt(0).toUpperCase()+e.slice(1)),"object"==typeof e&&!r.objectItems)throw"Can't add objects when itemValue option is not set";if(!e.toString().match(/^\s*$/)){if("string"==typeof e&&"INPUT"===this.$element[0].tagName){var s=e.split(",");if(s.length>1){for(var o=0;o<s.length;o++)this.add(s[o],!0);return void(i||r.pushVal())}}var l=r.options.itemValue(e),p=r.options.itemText(e),u=r.options.tagClass(e),c=r.options.itemTitle(e);if(""!=p&&void 0!=p){var h=t.grep(r.itemsArray,function(t){return r.options.itemValue(t)===l})[0];if(!h||r.options.allowDuplicates){if(!(r.items().toString().length+e.length+1>r.options.maxInputLength)){var m=t.Event("beforeItemAdd",{item:e,cancel:!1,options:a});if(r.$element.trigger(m),!m.cancel){r.itemsArray.push(e);var f=t('<span class="'+n(u)+(null!==c?'" title="'+c:"")+'">'+n(p)+'<i class="material-icons" data-role="remove">close</i></span>');f.data("item",e),r.findInputWrapper().before(f),f.after(" "),i||r.pushVal(),r.options.maxTags!==r.itemsArray.length&&r.items().toString().length!==r.options.maxInputLength||(r.$container.addClass("materialize-tags-max"),r.$input.blur(),r.$input.prop("readOnly",!0)),r.$element.trigger(t.Event("itemAdded",{item:e,options:a}))}}}else if(r.options.onTagExists){var d=t(".tag",r.$container).filter(function(){return t(this).data("item")===h});r.options.onTagExists(e,d)}}}}},remove:function(e,i,a){var n=this;if(n.objectItems&&(e="object"==typeof e?t.grep(n.itemsArray,function(t){return n.options.itemValue(t)==n.options.itemValue(e)}):t.grep(n.itemsArray,function(t){return n.options.itemValue(t)==e}),e=e[e.length-1]),e){var r=t.Event("beforeItemRemove",{item:e,cancel:!1,options:a});if(n.$element.trigger(r),r.cancel)return;t(".chip",n.$container).filter(function(){return t(this).data("item")===e}).remove(),-1!==t.inArray(e,n.itemsArray)&&n.itemsArray.splice(t.inArray(e,n.itemsArray),1)}i||n.pushVal(),n.options.maxTags>n.itemsArray.length&&(n.$container.removeClass("materialize-tags-max"),n.$input.prop("readOnly",!1)),0==n.itemsArray.length&&n.$input.siblings("label").first().removeClass("active"),n.$input.blur(),n.$element.trigger(t.Event("itemRemoved",{item:e,options:a}))},removeAll:function(){var e=this;for(t(".chip",e.$container).remove();e.itemsArray.length>0;)e.itemsArray.pop();e.pushVal(),e.$container.removeClass("materialize-tags-max"),e.$input.siblings("label").first().removeClass("active"),e.$input.prop("readOnly",!1),e.$input.blur()},refresh:function(){var e=this;t(".chip",e.$container).each(function(){var i=t(this),a=i.data("item"),r=(e.options.itemValue(a),e.options.itemText(a)),s=e.options.tagClass(a);i.attr("class",null),i.addClass("tag "+n(s)),i.contents().filter(function(){return 3==this.nodeType})[0].nodeValue=n(r)})},items:function(){return this.itemsArray},pushVal:function(){var e=this,i=t.map(e.items(),function(t){return e.options.itemValue(t).toString()});e.$element.val(i,!0).trigger("change"),e.$input.typeahead("val","")},build:function(e){var n=this;if(n.options=t.extend({},o,e),n.objectItems&&(!0===n.options.freeInput?n.options.freeInput=!0:n.options.freeInput=!1),i(n.options,"itemValue"),i(n.options,"itemText"),a(n.options,"tagClass"),n.options.typeaheadjs){var l=null,p={},u=n.options.typeaheadjs;t.isArray(u)?(l=u[0],p=u[1]):p=u,n.$input.typeahead(l,p).on("typeahead:selected",t.proxy(function(t,e){p.valueKey?n.add(e[p.valueKey]):n.add(e),n.$input.typeahead("val","")},n))}n.$container.on("click",t.proxy(function(t){n.$element.attr("disabled")||n.$input.removeAttr("disabled"),n.$input.focus()},n)),n.options.addOnBlur&&n.options.freeInput&&n.$input.on("focusout",t.proxy(function(t){n.add(n.$input.val()),n.$input.val("")},n)),n.$container.on("keydown","input",t.proxy(function(e){var i=t(e.target),a=n.findInputWrapper();if(n.$element.attr("disabled"))n.$input.attr("disabled","disabled");else{switch(e.which){case 8:if(n.options.deleteTagsOnBackspace&&0===r(i[0])){var s=a.prev();s&&n.remove(s.data("item"))}break;case 46:if(n.options.deleteTagsOnDeleteKey&&0===r(i[0])){var o=a.next();o&&n.remove(o.data("item"))}break;case 37:var l=a.prev();n.options.MoveTagOnLeftArrow&&0===i.val().length&&l[0]&&(l.before(a),i.focus());break;case 39:var p=a.next();n.options.MoveTagOnRightArrow&&0===i.val().length&&p[0]&&(p.after(a),i.focus())}var u=i.val().length;Math.ceil(u/5);i.attr("size",Math.max(this.inputSize,i.val().length))}},n)),n.$container.on("keydown","input",t.proxy(function(e){var i=t(e.target);if(n.$element.attr("disabled"))n.$input.attr("disabled","disabled");else{var a=i.val(),r=n.options.maxChars&&a.length>=n.options.maxChars;n.options.freeInput&&(s(e,n.options.confirmKeys)||r)&&(n.add(r?a.substr(0,n.options.maxChars):a),i.val(""),n.$input.typeahead&&n.$input.typeahead("val",""),e.preventDefault());var o=i.val().length;Math.ceil(o/5);i.attr("size",Math.max(this.inputSize,i.val().length))}},n)),n.$container.on("click","[data-role=remove]",t.proxy(function(e){n.$element.attr("disabled")||n.remove(t(e.target).closest(".chip").data("item"))},n)),n.options.itemValue===o.itemValue&&"INPUT"===n.$element[0].tagName&&n.add(n.$element.val())},destroy:function(){var t=this;t.$container.off("keydown","input"),t.$container.off("click","[role=remove]"),t.$container.remove(),t.$element.removeData("materialtags"),t.$element.show()},focus:function(){this.$input.focus()},input:function(){return this.$input},findInputWrapper:function(){for(var e=this.$input[0],i=this.$container[0];e&&e.parentNode!==i;)e=e.parentNode;return t(e)}},t.fn.materialtags=function(i,a,n){var r=[];return this.each(function(){var s=t(this).data("materialtags");if(s)if(i||a){if(void 0!==s[i]){if(3===s[i].length&&void 0!==n)o=s[i](a,null,n);else var o=s[i](a);void 0!==o&&r.push(o)}}else r.push(s);else s=new e(this,i),t(this).data("materialtags",s),r.push(s),t(this).val(t(this).val())}),"string"==typeof i?r.length>1?r:r[0]:r},t.fn.materialtags.defaults=o,t.fn.materialtags.Constructor=e;var l=t("<div />");t(function(){t("input[data-role=materialtags]").materialtags()})}(window.jQuery);
//# sourceMappingURL=materialize-tags.min.js.map
